﻿
-- УТРИРОВАННЫЙ (но работающий) ПРИМЕР

-- Автоматический показ ключей запуска макросов в конце строк меню выбора макроса

-- реализован через MMacro авторства John Doe от Tue 04 Dec 2018 10:59
-- https://forum.farmanager.com/viewtopic.php?p=151937#p151937
-- John Doe Thu 06 Dec 2018 11:43
-- https://forum.farmanager.com/viewtopic.php?p=151982#p151982
-- для автоматического вывода в меню ключей запуска макросов необходимо к определениям (т.е. к 'Macro'),
-- содержание поля description которых нужно завершить обозначением ключа, добавить спереди ещё одну букву 'M',
-- т.е. переименовать их в 'MMacro'.

-- При этом с помощью MMacro реализованы:

-- а) обозначение комбинаций клавиш, выводимых в правом столбце меню выбора макроса,
-- через дополнительное поле key2; это позволяет не привязываться
-- жёстко к базовой клавиатурной комбинации, а выводить любую подходящую для
-- конкретно случая, вплоть до того, что можно и просто одиночный хоткей
-- указывать, когда это целесообразно; а также это допускает введение в
-- основном поле key любое количество ключей, в т.ч. невалидных, что
-- вполне может понадобиться на практике.

-- б) подсветка в качестве быстрых клавиш последних букв ключей, указанных в правой колонке меню,
-- позволяющая активировать макрос как полной указанной клавиатурной комбинацией,
-- так и как дополнительной (по отношению к левой колонке меню) горячей клавишей
-- автор этих идей IgorZ Fri 07 Dec 2018 06:46
-- https://forum.farmanager.com/viewtopic.php?p=152011#p152011

local width = 55 -- ширина максимально длинного содержимого поля description в меню, формируемом данными макросами,
                 -- (в символах между кавычками) плюс 1 символ

local descr_fmt = "%-"..width.."s %s"
-- выравнивание строк меню выбора макроса производится по левому краю (флагом "%-")
-- для выравнивания правой колонки меню по правому краю нужно добавить в поле key перед крайним справа ключом нужное
-- количество дополнительный знаков пробелов

local function MMacro(m)
  if type(m.key2)=="string" then
    m.description = ("%-"..width.."s %s&%s"):format(m.description:gsub("&",""),m.key2:sub(1,-2),m.key2:sub(-1))
    s = m.key2:len()
    m.sortpriority = s
  end
  return Macro(m)
end

MMacro { area="shell"; key="F3";
key2="F3";
--selected=true;
sortpriority=1;
description="&Native: Просмотр .  .  .  .  .  .  .  .  .  .  .  .  . ";
id="4BEAFE6A-02AE-4C48-B7F2-6840CC085E2B"; flags="NoPluginPanels EmptyCommandLine";
action=function()
  Keys"F3"
end;
}

MMacro {
area="Info Shell"; key="F3"; key2="CtrlV";
selected=true;
id="ABA66E5D-FD26-4416-BDD8-1CA173C9A422";
description="&pImageView: просмотр картинок (VG)"; -- 70
  action = function()
    Plugin.Menu("9D4A59D9-AD2D-478C-8F66-7D233CBB788D","9D4A59D9-AD2D-478C-8F66-7D233CBB788D") -- Victor_VG 22:57 06-06-2015 http://forum.ru-board.com/topic.cgi?forum=5&topic=31718&start=6660#12
  end;
}

MMacro {
area="Info Shell"; key="CtrlAltShiftS"; key2="CtrlV";
id="8EFB0F01-9047-4CF7-9113-0C9E86A95E55";
sortpriority=60;
description="pImageView: просмотр картинок (v&ig)";
  action = function()
    Plugin.Menu("9D4A59D9-AD2D-478C-8F66-7D233CBB788D","9D4A59D9-AD2D-478C-8F66-7D233CBB788D") -- Victor_VG 22:57 06-06-2015 http://forum.ru-board.com/topic.cgi?forum=5&topic=31718&start=6660#12
  end;
}

MMacro {
--area="Shell"; key="F3"; key2="CtrlL"; flags="NoPluginPanels NoFolders";
area="Shell"; key="F3"; key2="AltF3"; flags="NoPluginPanels NoFolders";
description="встроенный редактор как вьюер (&jd)";              -- F4 CtrlL"; -- 70
-- description="Use internal editor as viewer";
-- John Doe Чт 21 мар, 2013 13:16 http://forum.farmanager.com/viewtopic.php?p=106198#p106198
-- goto:%FARProfile%\Macros\scripts\edi_lua\edi_StdMacros\F3.lu_
  action = function()
    Keys('F4')
    if Area.Dialog then Keys('Enter') end
    if Area.Editor and bit64.band(Editor.State,0x200)~=0x200 then Keys('CtrlL') end
  end;
}

MMacro {
area="Shell"; key="F3 CtrlQ"; key2="CtrlQ"; flags="NoPluginPanels NoFolders"; --sortpriority=80;
description="&Native: Быстрый просмотр"; -- 70
-- description="Use internal editor as viewer";
  action = function()
    Keys('CtrlQ')
  end;
}

-- БЛОК MEdiaInfo по файлу НАЧАЛО
local IMAGE_INFO_ID = "BC9E641B-74DF-47FC-BD48-8A0BDE79B8BA"
local MEDIA_INFO_ID = "919C1FC6-A571-4642-99DF-BDACE840ED18"

local function image_media_info()
   if not APanel.Folder then
      Keys("F11")
      if Menu.Select("Image Info",2) > 0 then
         Keys("Enter")
         if not (Dlg.Id == IMAGE_INFO_ID) then
            Keys("F11")
            if Menu.Select("Media Info",2) > 0 then
               Keys("Enter")
            else
               Keys("Esc")
            end
         end
      else
         Keys("Esc")
      end
   end
end

local function image_media_condition()
   return (Dlg.Id == IMAGE_INFO_ID) or (Dlg.Id == MEDIA_INFO_ID)
end

local function image_media_prev()
   if not APanel.Bof and Panel.Item(0,Panel.SetPosIdx(0,0)-1,0)~=".." then
      Keys("Esc Up")
      image_media_info()
   end
end

local function image_media_next()
   if not APanel.Eof then
      Keys("Esc Down")
      image_media_info()
   end
end

-- Вызов плагинов
MMacro { area="Shell Search"; key="F3"; key2="CtrlI";
id="5B0882A7-55BC-4556-9873-F3790B3A2090";
description="&pMEdiaInfo: по файлу под курсором (AleXH)"; -- 70
flags=""; -- description="Get MEdiaInfo";
action=image_media_info; }
MMacro { area="Shell Search"; key="";
id="6E9C8C52-84C2-4AB1-8C1E-393936E447C7";
description="pMEdiaInfo: по файлу под курсором (Ale&xH)  F3";
flags=""; -- description="Get MEdiaInfo";
action=image_media_info; }

-- Перемещение между файлами
MMacro { area="Dialog"; key="Up"; flags="";  description="Navigation Up"; condition=image_media_condition; action=image_media_prev; }
MMacro { area="Dialog"; key="Down"; flags=""; description="Navigation Down"; condition=image_media_condition; action=image_media_next; }
-- БЛОК MEdiaInfo по файлу КОНЕЦ

MMacro {
area="Shell"; key="F3"; key2="AltPgUp"; --priority=40;
description="pEMen&Ю: контекстное"; -- 70
flags="NoPluginPanels";
  action=function()
    Plugin.Open("EMenu") -- используется макрос "007_pluginOpen(maxRusov).lua" см.:
-- Max Rusov Вт 09 апр, 2013 14:45 http://forum.farmanager.com/viewtopic.php?p=107512#p107512
-- Добавь функции и вызывай плагин по имени: Plugin.Open("FarFTP")
-- имя плагина берётся из вызываемого по нативному F11 F3 диалогу "Информация о плагине"
    Keys("Enter")
--  Plugin.Menu("742910F1-02ED-4542-851F-DEE37C2E13B2","C8660293-6195-4303-9A5F-A6E7F603AE12") Keys="Enter" -- можно и так
  end;
}
